from cpl_core.application import ApplicationExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceProviderABC
from cpl_discord.service import DiscordBotServiceABC

from bot_core.configuration.bot_startup_settings import BotStartupSettings


class InitBotExtension(ApplicationExtensionABC):
    def __init__(self):
        ApplicationExtensionABC.__init__(self)

    async def run(self, config: ConfigurationABC, services: ServiceProviderABC):
        settings: BotStartupSettings = config.get_configuration(BotStartupSettings)

        bot: DiscordBotServiceABC = services.get_service(DiscordBotServiceABC, max_messages=settings.cache_max_messages)
